import java.io.*;

public class Ptc2Txt {
	private static final String toTxt = "@ABCDEFGHJKLMNOP~QRSTUVW@Ihfij{C|D^OPQRSTUVWXFGH`abcdefghijklmnopqrstuvwxymnOQMoUp`_\BuvAE@BDFHb[ACEGIJLNPRTVXZ\^`cegijklmnqtwz}~JKXYZ[\]^_`pqrstuvwxyz{|}";
	private static final String toHTxt = "@ABCDEFGHJKLMNOP~QRSTUVW !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~_\BuvAE@BDFHb[ACEGIJLNPRTVXZ\^`cegijklmnqtwz}~JKXYZ[\]^_`pqrstuvwxyz{|}";
	public static void main(String args[]){
		File f = null;
		InputStream is = null;
		BufferedInputStream bis = null;
		int p = 0;
		boolean half = false;
		if (args.length == 2 && args[0].equals("-h")) {
			half = true;
			p++;
		}
		try {
			f = new File(args[p]);
			if(!f.exists()&&!f.isFile()){
				System.err.println("̓t@Cw肵ĂB");
				return;
			}
			is = new FileInputStream(f);
			bis = new BufferedInputStream(is);
			byte[] head = new byte[12];
			byte[] size = new byte[4];
			// wb_̃`FbN
			bis.skip(0x24);
			bis.read(head, 0, 12);
			String h = new String(head);
			if(!h.equals("PETC0300RPRG")){
				System.err.println("v`RmkII PRGł͂܂B");
				return;
			}
			// vOXg̃TCY̎擾
			bis.skip(8);
			bis.read(size, 0, 4);
			int len = 0;
			for(int i = 3; i >= 0; i--) {
				int s = size[i];
				if(s < 0){
					s = s + 256;
				}
				len = len * 256 + s;
			}
			// 1oCgv`RtHgpɕϊĕWo͂
			String t = toTxt;
			if (half) { t = toHTxt; }
			for(int i = 0; i < len; i++){
				int c = bis.read();
				if(c == 13){
					// 13͉sR[h
					System.out.println();
				} else {
					if (c < 0) { c = c + 127; }
					System.out.print(t.substring(c,c+1));
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if(bis != null){
					bis.close();
				}
			} catch (IOException e) {
			}
			try {
				if(is != null){
					is.close();
				}
			} catch (IOException e) {
			}
		}
	}
}
